<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Grounding LLM</title>
    <style>
        body {
            font-family: 'Arial', sans-serif;
            margin: 40px;
            background-color: #f4f4f4; /* Set your desired background color */
        }

        h1 {
            color: #333;
        }
        h3 {
            justify-content: left;
            color: #333;
        }

        form {
            max-width: 500px;
            margin: 40px 0;
            padding: 25px;
            border: 1px solid #ccc;
            border-radius: 5px;
            background-color: #fff; /* Set your desired background color */
        }

        label {
            display: block;
            margin-bottom: 5px;
            color: #555;
        }

        input, select {
            width: 100%;
            padding: 8px;
            margin-bottom: 10px;
            box-sizing: border-box;
            border: 1px solid #ccc;
            border-radius: 3px;
        }


        input[type="submit"]:hover {
            background-color: #3c7a3f;
        }

        .highlight-box {
            background-color: #ddd; /* Set your desired highlighted box background color */
            padding: 10px;
            border-radius: 5px;
            margin-top: 15px; /* Adjust as needed */
        }
        .highlight-box-2 {
            background-color: #8dbe8f; /* Set your desired highlighted box background color */
            padding: 10px;
            border-radius: 5px;
            margin-top: 15px; /* Adjust as needed */
        }
       
        p {
            margin-top: 10px;
            color: #333;
        }

        .colored-paragraph {
            color: #3c7a3f; /* Change 'red' to the desired color */
        }

        p.error {
            color: red;
        }

        p.message {
            color: rgb(121, 120, 177);
        }

        .row {
            padding: 15px;
            border: 1px solid #ccc;
            border-radius: 5px;
            background-color: #fff;
            margin-bottom: 10px;
        }

        .form-box1 {
            max-width: 95%;
            max-height: 28%;
        }

        .rating {
            display: flex;
            flex-direction: row;
            justify-content: left;
            align-items: left;
        }

        .rating input {
            display: none;
        }

        .rating label {
            cursor: pointer;
            width: 25px;
            height: 25px;
            margin: 0 2px;
            font-size: 25px;
            line-height: 25px;
        }

        .rating label:before {
            content: '★';
        }

        .rating input:checked ~ label {
            color: #FFD700;
        }
        .button {
            background-color: #8dbe8f;
            color: white;
            border: none;
            padding: 10px 20px;
            cursor: pointer;
            border-radius: 5px;
            margin-bottom: 10px;
        }

        .button:hover {
            background-color: #3c7a3f;
        }

        .rating {
        display: flex;
        flex-direction: row;
        justify-content: left;
        align-items: left;
        direction: rtl; /* Change direction to left to right */
        }   

        .rating input[type="radio"] {
            float: left; 
            clear: none; 
        }
        .rating label {
            float: left; 
            clear: none; 
        }
        
    </style>
</head>
<body>
    <h1>Grounded output from LLM</h1>

    <p>The relevant information extracted from Knowlegde Graph and user's question are combined into a single user message. This is sent to the LLM's prompt and is instruced to answer/ improve answer based on the relevant information to generate grounded response. The response is expected to be :</p>
    <ul>
        <li>Reliable</li>
        <li>Accurate</li>
        <li>High quality</li>
        
    </ul>

    <!-- {% if results %}
    <div class="highlight-box">
        <h2>LLM's response</h2>
        {% for result in results %}
            {% for element in result %}
                <li>{{ element }}</li>
            {% endfor %}
        {% endfor %}
    </div>
    {% endif %} -->

    {% if LLM_prompt %}
    <div class="highlight-box">
        <h2>LLM's Prompt: Use the provided articles delimited by triple quotes to answer questions.</h2>  
        <p>{{ LLM_prompt }}</p>          
    </div>
    {% endif %}

    {% if grounded_output %}
    <div class="highlight-box-2">
        <h2>LLM's response</h2>        
            <p>{{ grounded_output }}</p>           
    </div>
    {% endif %}


    <div style="width: 800px; margin: 0 auto;padding-top: 20px;"></div>
        <h3>Rate ME</h3>
        <p>Assess the quality of the generated responses based on criteria such as relevance, coherence, fluency, and overall satisfaction.</p>
        <div class="rating">
            
            <input type="radio" id="star5" name="rating" value="5" onclick="rateReadme(5)">
            <label for="star5"></label>
            
    
            <input type="radio" id="star4" name="rating" value="4" onclick="rateReadme(4)">
            <label for="star4"></label>
   
    
            <input type="radio" id="star3" name="rating" value="3" onclick="rateReadme(3)">
            <label for="star3"></label>
          
    
            <input type="radio" id="star2" name="rating" value="2" onclick="rateReadme(2)">
            <label for="star2"></label>
            
    
            <input type="radio" id="star1" name="rating" value="1" onclick="rateReadme(1)">
            <label for="star1"></label>

            <textarea id="feedback5" name="feedback" style="display: none;"></textarea>
            <textarea id="feedback4" name="feedback" style="display: none;"></textarea>
            <textarea id="feedback3" name="feedback" style="display: none;"></textarea>
            <textarea id="feedback2" name="feedback" style="display: none;"></textarea>
            <textarea id="feedback1" name="feedback" style="display: none;"></textarea>

            
        </div>
    </div>

    <div style="width: 800px; margin: 0 auto;padding-top: 20px;"></div>
    <h3> Evaluation Metrics for the Grounding Pipeline</h3>
    <p> 1. The faithfulness metric measures the factual consistency of the generated answer against the given context. It is calculated from answer and retrieved context. The answer is scaled to (0,1) range. Higher the better. The generated answer is regarded as faithful if all the claims that are made in the answer can be inferred from the given context. </p>  
    {% if faithfulness %}
        <p class="colored-paragraph"> Faithfullness / Groundness score : {{ faithfulness }}</p>          
    </div>
    {% endif %}
    <p> 2. Answer Relevancy focuses on assessing how pertinent the generated answer is to the given prompt. A lower score is assigned to answers that are incomplete or contain redundant information and higher scores indicate better relevancy.</p>
    {% if relevancy %}
        <p class="colored-paragraph"> Answer Relevancy score : {{ relevancy }}</p>          
    </div>
    {% endif %}

    <!-- Add the following lines to include an image -->
    <div style="width: 800px; margin: 0 auto;padding-top: 20px;">
        <img src="/static/img/Arch_Neo4j.PNG" alt="Image Alt Text" style="max-width: 100%; height: auto;display: block; margin: 0 auto;">
    </div>

</body>


<script>
    function rateReadme(rating) {
        // Show the corresponding textarea for the clicked star
        var feedbackTextarea = document.getElementById('feedback' + rating);
        feedbackTextarea.style.display = 'block';
        
        // Capture the user feedback
        var feedback = prompt("Please provide your feedback for this rating:");
        if (feedback !== null) {
            feedbackTextarea.value = feedback;
        } else {
            // If the user cancels the prompt, hide the textarea
            feedbackTextarea.style.display = 'none';
        }
        
        // Hide other textareas for stars with lower ratings
        for (var i = 1; i <= 5; i++) {
            if (i !== rating) {
                var otherTextarea = document.getElementById('feedback' + i);
                otherTextarea.style.display = 'none';
                otherTextarea.value = ''; // Clear previous feedback
            }
        }
        
        // Send the rating and feedback to the server
        var data = {
            "rating": rating,
            "feedback": feedback
        };
        
        fetch('/rate_readme', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json',
            },
            body: JSON.stringify(data),
        })
        .then(response => response.json())
        .then(data => {
            console.log('Success:', data);
            // Handle success if needed
        })
        .catch((error) => {
            console.error('Error:', error);
            // Handle error if needed
        });
    }
</script>
</html>